local warp  = {}
warp.effect = love.graphics.newPixelEffect[[

extern number		time;
extern vec2			mouse;
extern vec2			screen;
extern sampler2D	backbuffer;

vec4 effect( vec4 color, Image tex, vec2 tc, vec2 pc )
	{
	vec2 position	= vec2( pc.x/screen.x, (screen.y-pc.y)/screen.y ); // Love's 'Y' axes inversion
	vec2 pixel		= 1./screen;
	vec4 me			= texture2D( backbuffer, position );
	vec2 rnd		= vec2( mod(fract(sin(dot(position + time * 0.01, vec2(14.9898,78.233))) * 43758.5453), 1.0),
	                mod(fract(sin(dot(position + time * 0.01, vec2(24.9898,44.233))) * 27458.5453), 1.0));
	vec2 nudge		= vec2(12.0 + 10.0 * cos(time * 0.4),
	                  12.0 + 10.0 * cos(time * 0.2));
	vec2 rate		= -0.005 + 0.02 * (0.5 + 0.5 * cos(nudge * (position.yx - 0.5) + 0.5 + 10*time * vec2(0.137, 0.262)));
	rate *= 6.0 * abs(vec2(0.5, 0.5) - mouse);
	rate += 0.5 * rate.yx;
	vec2 mult	= 1.0 - rate;
	vec2 jitter	= vec2(1.1 / screen.x, 1.1 / screen.y);
	vec2 offset = (rate * mouse) - (jitter * 0.5);
	vec4 source = texture2D(backbuffer, position * mult + offset + jitter * rnd);
	me = me * 0.05 + source * 0.95;
	return me;
	}
]]
return warp
